import { EventEmitter, OnInit } from '@angular/core';
import { FormBuilder, FormGroup } from '@angular/forms';
import { AuthProcessService, AuthProvider } from '../../services/auth-process.service';
import { Subscription } from 'rxjs';
import { MatFormFieldAppearance } from '@angular/material/form-field';
import { ThemePalette } from '@angular/material/core';
export declare class NgxAuthFirebaseuiLoginComponent implements OnInit {
    private platformId;
    authProcess: AuthProcessService;
    private formBuilder;
    logoUrl: string;
    providers: string[] | string;
    appearance: MatFormFieldAppearance;
    registrationEnabled: boolean;
    resetPasswordEnabled: boolean;
    messageOnAuthSuccess: string;
    messageOnAuthError: string;
    titleText: string;
    rememberMeText: string;
    loginButtonText: string;
    orLabelText: string;
    forgotPasswordText: string;
    dontHaveAnAccountText: string;
    createAccountButtonText: string;
    emailText: string;
    emailErrorRequiredText: string;
    emailErrorPatternText: string;
    passwordText: string;
    passwordErrorRequiredText: string;
    onSuccess: any;
    onError: any;
    onCreateAccountRequested: EventEmitter<void>;
    onResetPasswordRequested: EventEmitter<void>;
    onLoginButtonClicked: EventEmitter<void>;
    loginForm: FormGroup;
    authProviders: typeof AuthProvider;
    onErrorSubscription: Subscription;
    authenticationError: boolean;
    constructor(platformId: Object, authProcess: AuthProcessService, formBuilder: FormBuilder);
    get color(): string | ThemePalette;
    get colorAccent(): string | ThemePalette;
    ngOnInit(): void;
    updateAuthSnackbarMessages(): void;
    login(): Promise<void>;
}
